/*
 * agenda.cpp
 *
 *  Created on: 13/mag/2013
 *      Author: bertini
 */

#include "Promemoria.h"
#include <map>
#include <iostream>

int main() {
	std::multimap<Data, Promemoria, DataComparator> agenda;
	std::multimap<Data, Promemoria> agenda2; // se la classe chiave ha l'operatore < allora va bene anche questa dichiarazione

	Promemoria azione1;
	azione1.scadenza.mese = 5;
	azione1.scadenza.giorno = 5;
	azione1.titolo = "Esercizio STL vector";

	Promemoria azione2;
	azione2.scadenza.mese = 5;
	azione2.scadenza.giorno = 5;
	azione2.titolo = "Esercizio STL multimap";

	Promemoria azione3;
	azione3.scadenza.mese = 6;
	azione3.scadenza.giorno = 11;
	azione3.titolo = "Ultima lezione";

	agenda.insert(std::pair<Data, Promemoria>(azione1.scadenza, azione1));
	agenda.insert(std::pair<Data, Promemoria>(azione2.scadenza, azione2));
	agenda.insert(std::pair<Data, Promemoria>(azione3.scadenza, azione3));

	std::multimap<Data, Promemoria>::iterator it;
	for (it = agenda.begin(); it != agenda.end(); it++) {
		(*it).second.fatto = true;
	}

	std::multimap<Data, Promemoria>::iterator cercato;
	Data query(2014, 6, 11);
	cercato = agenda.find(query); // ricerca in albero binario: O(log n)
	if (cercato == agenda.end())
		std::cout << "Non trovo l'elemento: " << azione3.scadenza << std::endl;
	else
		std::cout << (*cercato).second.scadenza << " " << (*cercato).second.titolo
				<< std::endl; // uso funzione friend di Data per stampare la scadenza

	for (it = agenda.begin(); it != agenda.end(); it++) {
		std::cout << (*it).second.scadenza << std::endl; // uso funzione friend di Data
	}

	// esempio di uso di functor al di fuori di STL
	DataComparator dc;
	bool result = dc(azione1.scadenza, azione3.scadenza);
	if (result)
		std::cout << "azione1 ha una scadenza prima di azione3" << std::endl;
	else
		std::cout << "azione3 ha una scadenza uguale o dopo azione1" << std::endl;

}

